'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Download = function Download(_ref) {
  var logoUrl = _ref.logoUrl,
      name = _ref.name,
      description = _ref.description,
      btnTxt = _ref.btnTxt,
      downloadUrl = _ref.downloadUrl;

  var prefixCls = 'ehome-rcm-download';
  return _react2.default.createElement(
    'div',
    { className: prefixCls },
    _react2.default.createElement('img', { src: logoUrl, alt: 'logo' }),
    _react2.default.createElement(
      'div',
      { className: prefixCls + '-description' },
      _react2.default.createElement(
        'span',
        null,
        name
      ),
      _react2.default.createElement(
        'span',
        null,
        description
      )
    ),
    _react2.default.createElement(
      'a',
      { href: downloadUrl },
      btnTxt
    )
  );
};

Download.PropsType = {
  logoUrl: _propTypes2.default.string.isRequired,
  name: _propTypes2.default.string.isRequired,
  description: _propTypes2.default.string.isRequired,
  btnTxt: _propTypes2.default.string.isRequired,
  downloadUrl: _propTypes2.default.string.isRequired
};

exports.default = Download;