'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _antdMobile = require('antd-mobile');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Item = _antdMobile.List.Item;
var prefixCls = 'eh-select-organization';

function closest(el, selector) {
  var matchesSelector = el.matches || el.webkitMatchesSelector || el.mozMatchesSelector || el.msMatchesSelector;
  while (el) {
    if (matchesSelector.call(el, selector)) {
      return el;
    }
    el = el.parentElement;
  }
  return null;
}

var SelectOrganization = function (_ref) {
  _inherits(SelectOrganization, _ref);

  function SelectOrganization() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, SelectOrganization);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = SelectOrganization.__proto__ || Object.getPrototypeOf(SelectOrganization)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {}, _this.onWrapTouchStart = function (e) {
      // fix touch to scroll background page on iOS
      if (!/iPhone|iPod|iPad/i.test(navigator.userAgent)) {
        return;
      }
      var pNode = closest(e.target, '.am-modal-content');
      if (!pNode) {
        e.preventDefault();
      }
    }, _this.onClose = function () {
      var onClose = _this.props.onClose;

      onClose && onClose();
    }, _this.onChose = function (org) {
      var _this$props = _this.props,
          onClose = _this$props.onClose,
          onChose = _this$props.onChose;

      onChose && onChose(org);
      onClose && onClose();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SelectOrganization, [{
    key: 'componentDidMount',
    value: function componentDidMount() {}
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {}
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          visible = _props.visible,
          dataList = _props.dataList,
          nameKey = _props.nameKey,
          valueKey = _props.valueKey,
          title = _props.title;

      if (!visible) {
        return null;
      }
      return _react2.default.createElement(
        'div',
        { className: prefixCls },
        _react2.default.createElement(
          _antdMobile.Modal,
          {
            visible: visible,
            transparent: true,
            maskClosable: false,
            onClose: this.onClose,
            title: title,
            footer: [{ text: '取消', onPress: function onPress() {
                return _this2.onClose();
              } }],
            wrapProps: { onTouchStart: this.onWrapTouchStart },
            className: prefixCls
          },
          _react2.default.createElement(
            _antdMobile.List,
            null,
            dataList.map(function (org) {
              return _react2.default.createElement(
                Item,
                { key: org[valueKey], onClick: function onClick() {
                    return _this2.onChose(org);
                  } },
                org[nameKey] || ''
              );
            })
          )
        )
      );
    }
  }]);

  return SelectOrganization;
}(_react.PureComponent || _react.Component);

SelectOrganization.propTypes = {
  visible: _propTypes2.default.bool,
  dataList: _propTypes2.default.array,
  title: _propTypes2.default.string,
  onClose: _propTypes2.default.func,
  onChose: _propTypes2.default.func,
  // name的key值，决定从数据中获取哪个字段作为name，默认为name
  nameKey: _propTypes2.default.string,
  // value的key值，决定从数据中获取哪个字段作为value，默认为id
  valueKey: _propTypes2.default.string
};

SelectOrganization.defaultProps = {
  visible: false,
  dataList: [],
  title: '请选择企业',
  nameKey: 'name',
  valueKey: 'id'
};

exports.default = SelectOrganization;