'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _antdMobile = require('antd-mobile');

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Item = _antdMobile.List.Item;
var prefixCls = 'eh-select-project';

var SelectProject = function (_ref) {
  _inherits(SelectProject, _ref);

  function SelectProject() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, SelectProject);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = SelectProject.__proto__ || Object.getPrototypeOf(SelectProject)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      value: '',
      focus: false
    }, _this.onChange = function (value) {
      _this.setState({ value: value });
    }, _this.onFocus = function () {
      _this.setState({ focus: true });
    }, _this.onBlur = function () {
      _this.setState({ focus: false });
    }, _this.getContent = function () {
      var _this$state = _this.state,
          value = _this$state.value,
          focus = _this$state.focus;
      var _this$props = _this.props,
          projectList = _this$props.projectList,
          nameKey = _this$props.nameKey,
          valueKey = _this$props.valueKey;

      var dom = null;
      var reg = /^\s*$/;
      // 搜索框失去焦点，显示所有数据
      if (!focus) {
        dom = _react2.default.createElement(
          _antdMobile.List,
          null,
          projectList.map(function () {
            var project = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
            return _react2.default.createElement(
              Item,
              { key: project[valueKey], onClick: function onClick() {
                  return _this.saveData(project);
                } },
              project[nameKey] || ''
            );
          })
        );
      }

      // 搜索框有焦点
      else {
          // 没有搜索内容，显示默认界面
          if (reg.test(value)) {
            dom = _react2.default.createElement(
              'div',
              { className: prefixCls + '-text' },
              '\u8BF7\u8F93\u5165\u5173\u952E\u5B57\u67E5\u8BE2'
            );
          } else {
            var searchProjects = [];
            for (var i = 0; i < projectList.length; i++) {
              // const { projectName = '' } = projectList[i];
              if (projectList[i][nameKey].indexOf(value) !== -1) {
                searchProjects.push(projectList[i]);
              }
            }
            if (searchProjects.length > 0) {
              dom = _react2.default.createElement(
                _antdMobile.List,
                null,
                searchProjects.map(function () {
                  var project = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
                  return _react2.default.createElement(
                    Item,
                    { key: project[valueKey], onClick: function onClick() {
                        return _this.saveData(project);
                      } },
                    project[nameKey] || ''
                  );
                })
              );
            } else {
              dom = _react2.default.createElement(
                'div',
                { className: prefixCls + '-text' },
                '\u627E\u4E0D\u5230\u66F4\u591A\u7ED3\u679C'
              );
            }
          }
        }
      return dom;
    }, _this.saveData = function (project) {
      var onChose = _this.props.onChose;

      sessionStorage.setItem('selectedManagementProject', JSON.stringify(project));
      onChose && onChose();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SelectProject, [{
    key: 'render',
    value: function render() {
      var value = this.state.value;


      return _react2.default.createElement(
        'div',
        { className: prefixCls },
        _react2.default.createElement(
          _reactHelmet2.default,
          null,
          _react2.default.createElement(
            'title',
            null,
            '\u9009\u62E9\u7BA1\u7406\u9879\u76EE'
          )
        ),
        _react2.default.createElement(_antdMobile.SearchBar, {
          value: value,
          placeholder: '\u641C\u7D22',
          onChange: this.onChange,
          onBlur: this.onBlur,
          onFocus: this.onFocus
        }),
        _react2.default.createElement(
          'div',
          { className: prefixCls + '-content-wrap' },
          this.getContent()
        )
      );
    }
  }]);

  return SelectProject;
}(_react.PureComponent || _react.Component);

SelectProject.propTypes = {
  projectList: _propTypes2.default.array,
  title: _propTypes2.default.string,
  onChose: _propTypes2.default.func,
  // name的key值，决定从数据中获取哪个字段作为name，默认为name
  nameKey: _propTypes2.default.string,
  // value的key值，决定从数据中获取哪个字段作为value，默认为id
  valueKey: _propTypes2.default.string
};

SelectProject.defaultProps = {
  title: '请选择企业',
  nameKey: 'projectName',
  valueKey: 'projectId'
};

exports.default = SelectProject;